#version 330 core

// Input vertex data, different for all executions of this shader.
layout(location = 0) in vec3 vertexPosition_modelspace;

// Values that stay constant for the whole mesh.
uniform mat4 depth_view_proj;
uniform mat4 model;

// Send to fragment
out vec4 position_world_space;
out vec4 position_screen_space;

void main(){
	gl_Position = depth_view_proj * model * vec4(vertexPosition_modelspace, 1);
	position_screen_space = depth_view_proj * model * vec4(vertexPosition_modelspace, 1);
	position_world_space = model * vec4(vertexPosition_modelspace, 1);
}