#version 420 core

in vec2 texCoord;

layout(binding = 0) uniform sampler2D sceneTexture;

out vec4 fResult;

uniform int pLightCount;
uniform vec3 pLightPos[12];
uniform mat4 view_proj;

uniform int transparencyFlag;

int numGhosts = 3;

void main()
{
	vec2 texCoordFlip = -texCoord + vec2(1.0);
	vec2 deltaTexCoord = 0.75*(texCoord-texCoordFlip)*0.25;
	vec4 lensflareColor = vec4(0);
	vec2 texCoord_new;

	float brightTexture = 0.0;
	for(int i = -1; i < numGhosts; i++)
    {
		vec2 deltaTexCoord = 0.75*(texCoord-texCoordFlip)*0.25;
		lensflareColor.x += max( (texture(sceneTexture, fract(texCoordFlip + deltaTexCoord * float(i)*1.01) ).x - 0.96) , 0);
		lensflareColor.z += max( (texture(sceneTexture, fract(texCoordFlip + deltaTexCoord * float(i)*1.02) ).y - 0.96) , 0);
		lensflareColor.z += max( (texture(sceneTexture, fract(texCoordFlip + deltaTexCoord * float(i)*1.03) ).z - 0.96) , 0);
	}
	fResult = vec4( (lensflareColor.x *0.7 + texture(sceneTexture, texCoord).x), 
					(lensflareColor.y *1.0 + texture(sceneTexture, texCoord).y),
					(lensflareColor.z *1.0 + texture(sceneTexture, texCoord).z),  1);
	if (transparencyFlag == 0){
		if (lensflareColor.x != 0 || lensflareColor.y !=0 ||  lensflareColor.z !=0){
			fResult = vec4(lensflareColor.x, lensflareColor.y, lensflareColor.z, 1);
		}
	}
}